Bug 1823599 - Review Request: gjots2 - A heirarchical note jotter. Organise your ideas, notes, facts in a tree
Summary: Review Request: gjots2 - A heirarchical note jotter. Organise your ideas, not...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Alexander Ploumistos
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-04-14 01:42 UTC by Bob Hepple
Modified: 2020-05-17 06:13 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-05-14 02:28:46 UTC
Type: ---
Embargoed:
alex.ploumistos: fedora-review+


Attachments (Terms of Use)
gjots2.metainfo.xml (1.84 KB, application/xml)
2020-04-18 07:57 UTC, Bob Hepple
no flags Details
gjots2 screenshot showing block glyphs (36.06 KB, image/png)
2020-04-19 19:06 UTC, Alexander Ploumistos
no flags Details

Description Bob Hepple 2020-04-14 01:42:17 UTC
Spec URL: https://download.copr.fedorainfracloud.org/results/wef/gjots2/fedora-31-x86_64/01299215-gjots2/gjots2.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/wef/gjots2/fedora-31-x86_64/01299215-gjots2/gjots2-3.1.2-1.wef.src.rpm

Description: 

gjots2 ("gee-jots" or, if you prefer, "gyachts"!) is a way to marshall
and organise your text notes in a convenient, hierarchical way. For
example, use it for all your notes on Unix, personal bits and pieces,
recipes and even PINs and passwords (encrypted with ccrypt(1), gpg(1)
or openssl(1)).

You can also use it to "mind-map" your compositions - write down all
your thoughts and then start to organise them into a tree. By
manipulating the tree you can easily reorder your thoughts and
structure them appropriately.

Fedora Account System Username: wef

Comment 2 Bob Hepple 2020-04-17 03:32:24 UTC
Fixed FSF address - that's a problem that creeps in when a package has been around nearly 20 years!

SPEC URL: https://download.copr.fedorainfracloud.org/results/wef/gjots2/fedora-31-x86_64/01340097-gjots2/gjots2.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/wef/gjots2/fedora-31-x86_64/01340097-gjots2/gjots2-3.1.3-1.fc31.src.rpm

Comment 3 Zbigniew Jędrzejewski-Szmek 2020-04-17 07:11:24 UTC
Woah, why the license on top of the spec file? If you added that yourself, please remove it.
In Fedora, all spec files are implicitly licensed as MIT, and introducing a different
license for one file would be annoying.

URL: http://bhepple.freeshell.org/gjots → no https?
Source0... → the same

Summary: A note jotter. Organise your ideas, notes, facts in a hierarchy.
→ Summary fields shouldn't end in a dot. Maybe
"A note jotter — organise your ideas, notes, facts in a hierarchy"

Comment 4 Bob Hepple 2020-04-17 08:05:52 UTC
Re. license in spec file and the dot in Summary, please refer to the latest version.

I can change the Source0 to https but not the homepage. Is that a problem?

Comment 5 Zbigniew Jędrzejewski-Szmek 2020-04-17 08:09:12 UTC
(In reply to Bob Hepple from comment #4)
> Re. license in spec file and the dot in Summary, please refer to the latest
> version.
Ah, OK.

> I can change the Source0 to https but not the homepage. Is that a problem?
HTTPS is not mandatory. If the webserver doesn't support https, then obviously
using http or ftp is fine.

Comment 6 Alexander Ploumistos 2020-04-17 12:15:49 UTC
I'm not sure I haven't missed something, but once the issues I've found are fixed, I will check everything again.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file COPYING is not marked as %license
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/LicensingGuidelines/#_license_text

  What this means is that you should declare COPYING to be a license file
  in your %files section (remove it from %doc):
  %license COPYING

- The top entry in the changelog has the wrong date. Working late at night?

- I'm not sure what's causing the validation error of the AppData file,
  when I run it locally there's no error and it's the same in koji and mock.
  That being said, the specification has changed and the AppData file should
  be named gjots2.metainfo.xml and placed under /usr/share/metainfo/.
  Similarly, the <license> tag should now be <metadata_license>. A few tags
  that would be nice to have are <name>, <release> and <summary>. Also,
  <updatecontact> should be <update_contact>.

- Some more comments in the sections below


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "GNU General Public License (v2)", "GPL
     (v2 or later) (with incorrect FSF address)". 74 files have unknown
     license.

     I think that the overall license should be GPLv2, since it is the stricter
     of the two, or (if you prefer) you could change everything to GPLv2+.
     See https://fedoraproject.org/wiki/Licensing:FAQ?rd=Licensing/FAQ#What_is_.22effective_license.22_and_do_I_need_to_know_that_for_the_License:_tag.3F

     The rpmlint output will help you locate the files that still list the
     wrong FSF address.

[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.

     "Thu Apr 17" should be either "Thu Apr 16" or "Fri Apr 17" 

[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[!]: Spec file is legible and written in American English.

     There are several instances of British English, please change them to AE.

[-]: Package contains systemd file(s) if in need.
[-]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 389120 bytes in 11 files.

     You could create a gjots2-doc subpackage, but I don't think it's necessary.

[ ]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[!]: Package meets the Packaging Guidelines::Python

     The following files contain "/usr/bin/env python3" shebang lines:

     gjots2-3.1.3/bin/gjots2
     gjots2-3.1.3/bin/gjots2html.py
     gjots2-3.1.3/setup.py

     They should be changed to "/usr/bin/python3" (even though it's done
     automatically). The same goes for the shebang line in
     gjots2-3.1.3/uninstall.sh

     See https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_multiple_python_runtimes
     and https://docs.fedoraproject.org/en-US/packaging-guidelines/#_shebang_lines


[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.

     Why keep the man pages as ISO-8859-1 upstream and not UTF-8?

[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: gjots2-3.1.3-1.fc33.noarch.rpm
          gjots2-3.1.3-1.fc33.src.rpm
gjots2.noarch: W: spelling-error Summary(en_US) organise -> organist, organism, organize
gjots2.noarch: W: spelling-error %description -l en_US gyachts -> yachts, g yachts
gjots2.noarch: W: spelling-error %description -l en_US marshall -> Marshall, marshal, marshals
gjots2.noarch: W: spelling-error %description -l en_US organise -> organist, organism, organize
gjots2.noarch: W: spelling-error %description -l en_US ccrypt -> crypt, c crypt
gjots2.noarch: W: spelling-error %description -l en_US gpg -> pg, gig, gag
gjots2.noarch: W: spelling-error %description -l en_US openssl -> slope
gjots2.noarch: W: invalid-url URL: http://bhepple.freeshell.org/gjots <urlopen error [Errno 111] Connection refused>
gjots2.noarch: E: incorrect-fsf-address /usr/bin/docbook2gjots
gjots2.noarch: E: incorrect-fsf-address /usr/bin/gjots2docbook
gjots2.noarch: E: incorrect-fsf-address /usr/bin/gjots2emacs
gjots2.noarch: E: incorrect-fsf-address /usr/bin/gjots2html
gjots2.noarch: E: incorrect-fsf-address /usr/bin/gjots2lpr
gjots2.noarch: E: incorrect-fsf-address /usr/bin/gjots2org
gjots2.noarch: E: incorrect-fsf-address /usr/bin/org2gjots
gjots2.noarch: W: no-manual-page-for-binary gjots2emacs
gjots2.noarch: W: no-manual-page-for-binary gjots2html.py
gjots2.noarch: W: no-manual-page-for-binary gjots2lpr
gjots2.noarch: W: no-manual-page-for-binary gjots2org
gjots2.noarch: W: no-manual-page-for-binary org2gjots
gjots2.src: W: spelling-error Summary(en_US) organise -> organist, organism, organize
gjots2.src: W: spelling-error %description -l en_US gyachts -> yachts, g yachts
gjots2.src: W: spelling-error %description -l en_US marshall -> Marshall, marshal, marshals
gjots2.src: W: spelling-error %description -l en_US organise -> organist, organism, organize
gjots2.src: W: spelling-error %description -l en_US ccrypt -> crypt, c crypt
gjots2.src: W: spelling-error %description -l en_US gpg -> pg, gig, gag
gjots2.src: W: spelling-error %description -l en_US openssl -> slope
gjots2.src: W: invalid-url URL: http://bhepple.freeshell.org/gjots <urlopen error [Errno 111] Connection refused>
gjots2.src:42: W: mixed-use-of-spaces-and-tabs (spaces: line 3, tab: line 42)
gjots2.src: E: specfile-error warning: bogus date in %changelog: Thu Apr 17 2020 <bob.hepple> - 3.1.3-1
2 packages and 0 specfiles checked; 8 errors, 22 warnings.




Rpmlint (installed packages)
----------------------------
gjots2.noarch: W: spelling-error Summary(en_US) organise -> organist, organism, organize
gjots2.noarch: W: spelling-error %description -l en_US gyachts -> yachts, g yachts
gjots2.noarch: W: spelling-error %description -l en_US marshall -> Marshall, marshal, marshals
gjots2.noarch: W: spelling-error %description -l en_US organise -> organist, organism, organize
gjots2.noarch: W: spelling-error %description -l en_US ccrypt -> crypt, c crypt
gjots2.noarch: W: spelling-error %description -l en_US gpg -> pg, gig, gag
gjots2.noarch: W: spelling-error %description -l en_US openssl -> slope
gjots2.noarch: W: invalid-url URL: http://bhepple.freeshell.org/gjots <urlopen error [Errno -2] Name or service not known>
gjots2.noarch: E: incorrect-fsf-address /usr/bin/docbook2gjots
gjots2.noarch: E: incorrect-fsf-address /usr/bin/gjots2docbook
gjots2.noarch: E: incorrect-fsf-address /usr/bin/gjots2emacs
gjots2.noarch: E: incorrect-fsf-address /usr/bin/gjots2html
gjots2.noarch: E: incorrect-fsf-address /usr/bin/gjots2lpr
gjots2.noarch: E: incorrect-fsf-address /usr/bin/gjots2org
gjots2.noarch: E: incorrect-fsf-address /usr/bin/org2gjots
gjots2.noarch: W: no-manual-page-for-binary gjots2emacs
gjots2.noarch: W: no-manual-page-for-binary gjots2html.py
gjots2.noarch: W: no-manual-page-for-binary gjots2lpr
gjots2.noarch: W: no-manual-page-for-binary gjots2org
gjots2.noarch: W: no-manual-page-for-binary org2gjots
gjots2.noarch: E: invalid-appdata-file /usr/share/appdata/gjots2.appdata.xml
1 packages and 0 specfiles checked; 8 errors, 13 warnings.



Source checksums
----------------
http://downloads.sourceforge.net/gjots2/gjots2-3.1.3.tgz :
  CHECKSUM(SHA256) this package     : 53cd252a1bda6beadab476ecf8258164436abc87f0bf8c53a3a63ef9afb25ce7
  CHECKSUM(SHA256) upstream package : 53cd252a1bda6beadab476ecf8258164436abc87f0bf8c53a3a63ef9afb25ce7


Requires
--------
gjots2 (rpmlib, GLIBC filtered):
    /usr/bin/python3
    /usr/bin/sh
    gtk3
    gtksourceview4
    python(abi)
    python3-gobject



Provides
--------
gjots2:
    application()
    application(gjots2.desktop)
    gjots2
    metainfo()
    metainfo(gjots2.appdata.xml)
    python3.8dist(gjots2)
    python3dist(gjots2)

Comment 7 Bob Hepple 2020-04-18 07:57:06 UTC
Created attachment 1679808 [details]
gjots2.metainfo.xml

Thanks for the review, Alexander.

I've had a bit of a look at the appdata issue and it seems that most (if not all) applications (in f-31, at least) are still using appdata, not metainfo. Those which use metainfo seem to be fonts or other sorts of data.

To compound my confusion, there are many applications (eg eog!) that have an appdata file in /usr/share/metainfo! There are also metainfo files in /usr/share/appdata - again they seem to be for fonts and other data files rather than programs!!

So should it be appdata for programs and metainfo for fonts/data? 

Already my head is spinning!

So I've done my best and converted it to metainfo per the spec at https://www.freedesktop.org/software/appstream/docs/chap-Quickstart.html and following the examples on my f-31 system but it just won't pass validation although 'xmlstarlet val' is happy with it:

$ appstream-util validate-relax --nonet gjots2.metadata.xml 
gjots2.metadata.xml: No valid root node specified

Any idea what might be wrong? If I can't fix this, I suggest we revert to the old appdata format - I'll be in good company like google-chrome, abiword and others ...

Comment 8 Bob Hepple 2020-04-18 11:58:42 UTC
Oh wait ... the problem is the _filename_. If I call it org.gnome.gjots2.appdata.xml it's happy! Or org.gjots2.appdata.xml. Or gjots2.appdata.xml! But not gjots2.metadata.xml.

I tried changing the <id> to gjots2 (so that the filename fits the pattern %{id}.metainfo.xml) but it still fails.

Any more ideas? I'm tearing my hair here!

Comment 9 Alexander Ploumistos 2020-04-18 13:25:01 UTC
Hi Bob,

For compatibility reasons, older files named xyz.appdata.xml and placed in /usr/share/appdats are still treated as valid by appstream-util. From the spec's page:

Note

Component metadata of type desktop-application as described in Section 2.2, “Desktop Applications” can be installed with an .appdata.xml extension as well for historical reasons. AppStream implementations will read the XML files as long as they end up in the right location on the filesystem. 


Legacy Path

AppStream tools scan the /usr/share/appdata/ path for legacy compatibility as well. It should not be used anymore by new software though, even on older Linux distributions (like RHEL 7 and Ubuntu 16.04 LTS) the metainfo path is well supported. Support for the legacy path will likely be dropped completely with a future AppStream 1.0 release. 


When the specification for the <id> tag changed, a couple of upstream projects with which I was working at the time opted to use net.sourceforge.<project> as their tag, since the projects are hosted on sf.net. You could do the same, e.g.
<id>net.sourceforge.gjots2</id>
or use the gjots2 home page domain, if you think it will be around for the foreseeable future:
<id>org.freeshell.bhepple.gjots2</id>

Did you happen to read https://www.freedesktop.org/software/appstream/docs/chap-Metadata.html#tag-id-generic ?


Please note that the file should be named gjots2.appdata.xml or gjots2.metainfo.xml; gjots2.metadata.xml is not a valid name and appstream-util will refuse to validate it (it's not difficult to see why you got confused). You could also have the entire id string before metainfo.xml, e.g. net.sourceforge.gjots2.metainfo.xml. This is also "encouraged" for desktop files:
https://specifications.freedesktop.org/desktop-entry-spec/latest/

By the way, the "Encoding" key in your desktop file has been deprecated for quite some time.

I hope all that helps.

Comment 10 Bob Hepple 2020-04-19 08:51:20 UTC
Thank you so much Alexander! More insomnia coding on my behalf, the more I stared at it the less I grokked!!

I think this one is now up to date with all the comments. Sorry for delay ...

SPEC URL: https://download.copr.fedorainfracloud.org/results/wef/gjots2/fedora-31-x86_64/01341783-gjots2/gjots2.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/wef/gjots2/fedora-31-x86_64/01341783-gjots2/gjots2-3.1.4-1.fc31.src.rpm

Comment 11 Alexander Ploumistos 2020-04-19 19:06:11 UTC
Created attachment 1680099 [details]
gjots2 screenshot showing block glyphs

Hello Bob,

Kudos for the work so far and especially with the AppStream metadata. As for the id tag, it needs to conform to the reverse-DNS scheme (this is copied from the link I gave you):

"The ID must follow a reverse-DNS scheme, consisting of {tld}.{vendor}.{product}, for example org.kde.Gwenview or com.hugski.ColorHug2. Ownership of {vendor}.{tld} in the domain name system guarantees uniqueness of IDs."

In other words, this should be one of the strings I have proposed or something similar, if you have a better idea.

As for the "Encoding=UTF-8" key in gjots2.desktop, I think it's been over a decade that it was dropped from the specification, it's safe to lose it.


Other issues:

1. Licensing

Unless you want to add or remove the "or later" part everywhere in your upstream code, the package's license in the spec file should be GPLv2 and not GPLv2+, because the "effective license" in this case is GPLv2.
https://fedoraproject.org/wiki/Licensing:FAQ?rd=Licensing/FAQ#What_is_.22effective_license.22_and_do_I_need_to_know_that_for_the_License:_tag.3F
https://docs.fedoraproject.org/en-US/packaging-guidelines/LicensingGuidelines/

in your %files section, change

%doc AUTHORS COPYING ChangeLog README doc/gjots2.gjots

to

%license COPYING
%doc AUTHORS ChangeLog README doc/gjots2.gjots



2. American English spelling

There are several instances of "organise", that should be "organize". Oddly, the Cambridge Dictionary doesn't have "marshall", about which rpmlint complains, whereas Webster's lists it as an alternate spelling of "marshal". What's more odd, a couple of Australian online dictionaries do not consider it as valid.



3. When I run gjots2 and select "New", I get a series of block glyphs, as though I'm missing support for a specific language (see attachment). What are these?


We're almost there!

Comment 12 Miro Hrončok 2020-04-20 07:47:33 UTC
  %check
  desktop-file-install

Is not good: You should either desktop-file-validate the specfile in %check, or desktop-file-install (which also validates as a side effect) from %install. Installing files from %check is dangerous, because in certain circumstances, %check can be skipped entirely. See https://docs.fedoraproject.org/en-US/packaging-guidelines/#_desktop_file_install_usage



--------


  sed -i -e 's@lib/gjots2@lib/python%{python3_version}/site-packages/gjots2@g' setup.py

Why is this actually needed? In what context does this change happen? Please, add a comment to the spec that explains this.



--------


  %{python3_sitelib}/%{name}-%{version}-py%{python3_version}.egg-info

Consider adding leading slash to ensure this remains a directory.

Comment 13 Bob Hepple 2020-04-20 08:48:54 UTC
Thanks Alexander and Miro for useful input. I will need a few days to catch up with this (real life intervenes).

In the meantime and now that we've got metainfo more or less working, do you know if it's actually used? I tried sway and gnome but they don't appear to access the file. Nor does dnfdragora. Having totally bogus entries in it does not appear to upset rpm. So - where is it actually used?

Comment 14 Miro Hrončok 2020-04-20 09:06:35 UTC
When the software repositories are created, the contents of those file are scrapped/loaded to a central place and than offered as metadata for e.g. GNOME software.

You could probably somehow reproduce locally (although I have never actually tried this and the instructions are not complete):

 1. put the built rpms into an empty directory
 2. run createrpo over them to create a DNF repository
 3. run appstream-builder to extract the appdata
 4. run modifyrepo to merge the appdata to the repo metadata
 5. add a repo file to your system with file:// URL
 6. see GNOME software



However, I don't know all the command line options and switches to use. There is an easier way. Build the package in https://copr.fedorainfracloud.org/ -> it will give you a repository with appdata.

Comment 15 Bob Hepple 2020-04-21 02:09:55 UTC
Thanks for the explanation, Miro. At least it makes sense now.

Comment 16 Bob Hepple 2020-05-02 08:18:50 UTC
Hello again! Having dug out from the immediate real life time sinks I've been able to pick this up again.

New build below addressing all the points raised so far (I believe).

Alexander - I can't replicate your block icon problem on my system. Do you have anything in your ~/.gjotsfile ?? What is your locale? Mine is LC_ALL=en_AU.utf8 and LANG=C.

SPEC URL: https://download.copr.fedorainfracloud.org/results/wef/gjots2/fedora-31-x86_64/01362427-gjots2/gjots2.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/wef/gjots2/fedora-31-x86_64/01362427-gjots2/gjots2-3.1.5-1.fc31.src.rpm

Comment 17 Bob Hepple 2020-05-02 08:34:57 UTC
Oh! Miro - sorry, I didn't quite understand this one:


>  %{python3_sitelib}/%{name}-%{version}-py%{python3_version}.egg-info
> Consider adding leading slash to ensure this remains a directory.

%{python3_sitelib} expands to /usr/lib/python3.7/site-packages - surely it always has a leading slash?

Comment 18 Miro Hrončok 2020-05-02 08:41:28 UTC
%{python3_sitelib}/%{name}-%{version}-py%{python3_version}.egg-info/

Comment 19 Alexander Ploumistos 2020-05-02 12:24:52 UTC
Hello Bob,

Good job with all the changes!

(In reply to Bob Hepple from comment #16)
> Alexander - I can't replicate your block icon problem on my system. Do you
> have anything in your ~/.gjotsfile ?? What is your locale? Mine is
> LC_ALL=en_AU.utf8 and LANG=C.

I don't have LANG defined, but everything else is en_US.UTF-8 and the .gjotsfile was empty. In the meantime I've moved to Fedora 32 and with your latest changes, I didn't get these blocks, so we can chalk it off as gremlins I guess.

When I tried to launch gjots2 in F32 I noticed that I was getting the generic executable icon and not the png in /usr/share/pixmaps. In the desktop file you have "Icon=gjots2", but the file is called gjots.png. According to the specification, it shouldn't have worked before and I don't know why it did, but you should rename the image to gjots2.png. When I renamed the file I did get the right icon. My bad, I didn't think twice about that when I saw it before.

By the way, with HiDPI/4K displays becoming commonplace (I still don't have one) graphics are growing huge these days. If you ever need any help creating a higher resolution icon, I'm sure that you can ask on the design team's mailing list and someone should be able to help you - there are a lot of talented people working on Fedora.


Just add the trailing slash, rename the icon file and we're good to go.


Thanks again Miro!

Comment 20 Bob Hepple 2020-05-03 07:11:52 UTC
egg-info is a file in this package, not a directory so I am not giving it a trailing slash after all.

Here is the latest build:

SPEC URL: https://download.copr.fedorainfracloud.org/results/wef/gjots2/fedora-31-x86_64/01363503-gjots2/gjots2.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/wef/gjots2/fedora-31-x86_64/01363503-gjots2/gjots2-3.1.6-1.fc31.src.rpm

Cheers and thanks again for the reviews!

Comment 21 Miro Hrončok 2020-05-03 08:00:28 UTC
> egg-info is a file in this package, not a directory so I am not giving it a trailing slash after all.

Oh, in that case, maybe BuildRequires: python3-setuptools is not needed, becasue setuptools create a directory. Let me check...

Comment 22 Miro Hrončok 2020-05-03 08:03:40 UTC
Yes, the setup.py has:

   from distutils.core import setup

No, setuptools.

Comment 23 Alexander Ploumistos 2020-05-03 12:02:40 UTC
Yup, it builds fine without python3-setuptools.

*Sigh*

One more little thing to do and we can put this behind us…

Comment 25 Alexander Ploumistos 2020-05-03 23:07:14 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 378880 bytes in 10 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: gjots2-3.1.6-2.fc33.noarch.rpm
          gjots2-3.1.6-2.fc33.src.rpm
gjots2.noarch: W: spelling-error %description -l en_US gyachts -> yachts, g yachts
gjots2.noarch: W: spelling-error %description -l en_US ccrypt -> crypt, c crypt
gjots2.noarch: W: spelling-error %description -l en_US gpg -> pg, gig, gag
gjots2.noarch: W: spelling-error %description -l en_US openssl -> slope
gjots2.noarch: W: no-manual-page-for-binary gjots2emacs
gjots2.noarch: W: no-manual-page-for-binary gjots2html.py
gjots2.noarch: W: no-manual-page-for-binary gjots2lpr
gjots2.noarch: W: no-manual-page-for-binary gjots2org
gjots2.noarch: W: no-manual-page-for-binary org2gjots
gjots2.src: W: spelling-error %description -l en_US gyachts -> yachts, g yachts
gjots2.src: W: spelling-error %description -l en_US ccrypt -> crypt, c crypt
gjots2.src: W: spelling-error %description -l en_US gpg -> pg, gig, gag
gjots2.src: W: spelling-error %description -l en_US openssl -> slope
2 packages and 0 specfiles checked; 0 errors, 13 warnings.




Rpmlint (installed packages)
----------------------------
gjots2.noarch: W: spelling-error %description -l en_US gyachts -> yachts, g yachts
gjots2.noarch: W: spelling-error %description -l en_US ccrypt -> crypt, c crypt
gjots2.noarch: W: spelling-error %description -l en_US gpg -> pg, gig, gag
gjots2.noarch: W: spelling-error %description -l en_US openssl -> slope
gjots2.noarch: W: invalid-url URL: http://bhepple.freeshell.org/gjots <urlopen error [Errno -2] Name or service not known>
gjots2.noarch: W: no-manual-page-for-binary gjots2emacs
gjots2.noarch: W: no-manual-page-for-binary gjots2html.py
gjots2.noarch: W: no-manual-page-for-binary gjots2lpr
gjots2.noarch: W: no-manual-page-for-binary gjots2org
gjots2.noarch: W: no-manual-page-for-binary org2gjots
1 packages and 0 specfiles checked; 0 errors, 10 warnings.



Source checksums
----------------
https://downloads.sourceforge.net/gjots2/gjots2-3.1.6.tgz :
  CHECKSUM(SHA256) this package     : 475f49823a1b5a57ee8338c161570d19391e1cbfdc6fe30e2e18e9a7c953f89f
  CHECKSUM(SHA256) upstream package : 475f49823a1b5a57ee8338c161570d19391e1cbfdc6fe30e2e18e9a7c953f89f


Requires
--------
gjots2 (rpmlib, GLIBC filtered):
    /usr/bin/bash
    /usr/bin/python3
    gtk3
    gtksourceview4
    python(abi)
    python3-gobject



Provides
--------
gjots2:
    application()
    application(gjots2.desktop)
    gjots2
    metainfo()
    metainfo(gjots2.metainfo.xml)
    python3.8dist(gjots2)
    python3dist(gjots2)



Generated by fedora-review 0.7.5 (5fa5b7e) last change: 2020-02-16
Command line :/usr/bin/fedora-review -b 1823599
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Python
Disabled plugins: R, fonts, Perl, SugarActivity, PHP, Ocaml, Haskell, C/C++, Java
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH



Everything looks good, package is approved!

Comment 26 Bob Hepple 2020-05-04 06:28:10 UTC
Thanks everyone!!

I've kicked off the un-retire process.

Comment 27 Fedora Update System 2020-05-05 22:46:00 UTC
FEDORA-2020-19e53d3ab0 has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2020-19e53d3ab0

Comment 28 Fedora Update System 2020-05-05 22:47:02 UTC
FEDORA-2020-e75c278601 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-e75c278601

Comment 29 Fedora Update System 2020-05-06 02:23:44 UTC
FEDORA-2020-19e53d3ab0 has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-19e53d3ab0 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-19e53d3ab0

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 30 Fedora Update System 2020-05-06 02:59:07 UTC
FEDORA-2020-e75c278601 has been pushed to the Fedora 31 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-e75c278601 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-e75c278601

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 31 Fedora Update System 2020-05-14 02:28:46 UTC
FEDORA-2020-e75c278601 has been pushed to the Fedora 31 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 32 Fedora Update System 2020-05-14 02:35:51 UTC
FEDORA-2020-19e53d3ab0 has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 33 Fedora Update System 2020-05-16 23:06:40 UTC
FEDORA-EPEL-2020-239a92e692 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2020-239a92e692

Comment 34 Fedora Update System 2020-05-16 23:12:45 UTC
FEDORA-EPEL-2020-3bfe11ae0b has been submitted as an update to Fedora EPEL 8. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2020-3bfe11ae0b

Comment 35 Fedora Update System 2020-05-17 04:27:38 UTC
FEDORA-EPEL-2020-239a92e692 has been pushed to the Fedora EPEL 7 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2020-239a92e692

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 36 Fedora Update System 2020-05-17 06:13:42 UTC
FEDORA-EPEL-2020-3bfe11ae0b has been pushed to the Fedora EPEL 8 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2020-3bfe11ae0b

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.


Note You need to log in before you can comment on or make changes to this bug.